class PlaceNotFoundError(Exception):
    """Query provided did not lead to any city or populated area"""    
    def __init__(self, query):
        self.query = query
        super().__init__(f"Could not find any place on geonames.org of feature classes A and P by query '{self.query}'")